UNIXServer -

# class UNIXServer

- UNIXServer
- UNIXSocket
- Socket
- IO
- Reference
- Object

## Overview

A local interprocess communication server socket.

Only available on UNIX and UNIX-like operating systems.

Example usage:

    require "socket"

    def handle_client(client)
      message = client.gets
      client.puts message
    end

    server = UNIXServer.new("/tmp/myapp.sock")
    while client = server.accept?
      spawn handle_client(client)
    end

## Included Modules

- Socket::Server

## Defined in:

## Constructors

- .new(path : String, type : Type = Type::STREAM, backlog : Int = 128)

  Creates a named UNIX socket, listening on a filesystem pathname.

- .new(*, fd : Int32, type : Type = Type::STREAM, path : String? = nil)

  Creates a UNIXServer from an already configured raw file descriptor

## Class Method Summary

- .open(path, type : Type = Type::STREAM, backlog = 128, &block)

  Creates a new UNIX server and yields it to the block.

## Instance Method Summary

- #accept? : UNIXSocket?

  Accepts an incoming connection.

- #close(delete = true)

  Closes the socket, then deletes the filesystem pathname if it exists.

### Instance methods inherited from module `Socket::Server`

accept : IO
accept(&block) accept, accept? : IO?
accept?(&block) accept?

### Instance methods inherited from class `UNIXSocket`

local_address local_address, path : String? path, receive receive, remote_address remote_address

### Constructor methods inherited from class `UNIXSocket`

new(path : String, type : Type = Type::STREAM)
new(*, fd : Int32, type : Type = Type::STREAM, path : String? = nil) new

### Class methods inherited from class `UNIXSocket`

open(path, type : Type = Type::STREAM, &block) open, pair(type : Type = Type::STREAM)
pair(type : Type = Type::STREAM, &block) pair

### Instance methods inherited from class `Socket`

accept : Socket accept, accept? accept?, bind(addr, &block)
bind(host : String, port : Int)
bind(port : Int)
bind(addr) bind, blocking blocking, blocking=(value) blocking=, broadcast=(val : Bool) broadcast=, broadcast? broadcast?, close_on_exec=(arg : Bool) close_on_exec=, close_on_exec? close_on_exec?, close_read close_read, close_write close_write, closed? : Bool closed?, connect(addr, timeout = nil, &block)
connect(addr, timeout = nil) : Nil
connect(host : String, port : Int, connect_timeout = nil) connect, family : Family family, fcntl(cmd, arg = 0) fcntl, fd : Int32 fd, finalize finalize, getsockopt(optname, optval, level = LibC::SOL_SOCKET) getsockopt, inspect(io : IO) : Nil inspect, keepalive=(val : Bool) keepalive=, keepalive? keepalive?, linger linger, linger=(val : Int?) linger=, listen(backlog : Int = SOMAXCONN)
listen(backlog : Int = SOMAXCONN, &block) listen, protocol : Protocol protocol, receive(max_message_size = 512) : Tuple(String, Address)
receive(message : Bytes) : Tuple(Int32, Address) receive, recv_buffer_size recv_buffer_size, recv_buffer_size=(val : Int32) recv_buffer_size=, reuse_address=(val : Bool) reuse_address=, reuse_address? reuse_address?, reuse_port=(val : Bool) reuse_port=, reuse_port? reuse_port?, send(message, to addr : Address) : Int32
send(message) : Int32 send, send_buffer_size send_buffer_size, send_buffer_size=(val : Int32) send_buffer_size=, setsockopt(optname, optval, level = LibC::SOL_SOCKET) setsockopt, tty? tty?, type : Type type

### Constructor methods inherited from class `Socket`

new(fd : Int32, family, type, protocol = Protocol::IP, blocking = false)
new(family, type, protocol = Protocol::IP, blocking = false) new

### Class methods inherited from class `Socket`

fcntl(fd, cmd, arg = 0) fcntl, ip?(string : String) ip?, tcp(family : Family, blocking = false) tcp, udp(family : Family, blocking = false) udp, unix(type : Type = Type::STREAM, blocking = false) unix

### Instance methods inherited from module `IO::Evented`

evented_close evented_close, evented_read(slice : Bytes, errno_msg : String, &block) : Int32 evented_read, evented_reopen evented_reopen, evented_send(slice : Bytes, errno_msg : String, &block) : Int32 evented_send, evented_write(slice : Bytes, errno_msg : String, &block) : Nil evented_write, read_timeout : Time::Span? read_timeout, read_timeout=(read_timeout : Number) : Number
read_timeout=(timeout : Time::Span?) : Time::Span? read_timeout=, write_timeout : Time::Span? write_timeout, write_timeout=(write_timeout : Number) : Number
write_timeout=(timeout : Time::Span?) : Time::Span? write_timeout=

### Instance methods inherited from module `IO::Buffered`

buffer_size buffer_size, buffer_size=(value) buffer_size=, close : Nil close, flush flush, peek : Bytes? peek, read(slice : Bytes) read, read_buffering=(read_buffering) read_buffering=, read_buffering? read_buffering?, rewind rewind, sync=(sync) sync=, sync? sync?, unbuffered_close unbuffered_close, unbuffered_flush unbuffered_flush, unbuffered_read(slice : Bytes) unbuffered_read, unbuffered_rewind unbuffered_rewind, unbuffered_write(slice : Bytes) unbuffered_write, write(slice : Bytes) : Nil write

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? closed?, each_byte(&block) : Nil
each_byte each_byte, each_char(&block) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, gets(delimiter : Char, limit : Int, chomp = false) : String?
gets(delimiter : Char, chomp = false) : String?
gets(chomp = true) : String?
gets(limit : Int, chomp = false) : String?
gets(delimiter : String, chomp = false) : String? gets, gets_to_end : String gets_to_end, peek : Bytes? peek, pos pos, pos=(value) pos=, print(*objects : UNDERSCORE) : Nil
print(obj) : Nil print, printf(format_string, *args) : Nil
printf(format_string, args : Array | Tuple) : Nil printf, puts(*objects : UNDERSCORE) : Nil
puts : Nil
puts(obj) : Nil
puts(string : String) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, &block) read_at, read_byte : UInt8? read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char? read_char, read_fully(slice : Bytes) read_fully, read_fully?(slice : Bytes) read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol? = nil) set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) write_bytes, write_utf8(slice : Bytes) write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : UInt64
copy(src, dst) : UInt64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &block) pipe

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(path : String, type : Type = Type::STREAM, backlog : Int = 128) #

Creates a named UNIX socket, listening on a filesystem pathname.

Always deletes any existing filesystam pathname first, in order to cleanup any leftover socket file.

The server is of stream type by default, but this can be changed for another type. For example datagram messages:

    UNIXServer.new("/tmp/dgram.sock", Socket::Type::DGRAM)

def self.new(*, fd : Int32, type : Type = Type::STREAM, path : String? = nil) #

Creates a UNIXServer from an already configured raw file descriptor

## Class Method Detail

def self.open(path, type : Type = Type::STREAM, backlog = 128, &block) #

Creates a new UNIX server and yields it to the block. Eventually closes the server socket when the block returns.

Returns the value of the block.

## Instance Method Detail

def accept? : UNIXSocket? #

Accepts an incoming connection.

Returns the client socket or `nil` if the server is closed after invoking this method.

def close(delete = true) #

Closes the socket, then deletes the filesystem pathname if it exists.